//
//  ViewController.m
//  iPDCApp
//
//  Created by jije jijesoft on 2018/1/3.
//  Copyright © 2018年 jijesoft. All rights reserved.
//

#import "ViewController.h"

#define URL_testlink @"https://link.c9pg.com:11911/restApi"

@interface ViewController ()
{
    iPDCManager* m_iPDC;
}
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    m_iPDC = [[iPDCManager alloc] initWithDelegate:self];
    NSMutableDictionary *properties = [NSMutableDictionary dictionary];
    BOOL bEnableRushMode = YES;
    if (bEnableRushMode) {
        //set rush mode.
        [properties setValue:@"true" forKey:Prop_RushMode];
        [properties setValue:URL_testlink forKey:Prop_UploadUrl];
        [properties setValue:@60 forKey:Prop_CheckInterval];
        [properties setValue:@3 forKey:Prop_FailedThreshold];
    }
    BOOL bDisableQC = NO;//Quickchip EMV is supported by default.
    if (bDisableQC) {
        [properties setValue:@"false" forKey:Prop_QuickChip];
    }
    BOOL bSupportIPP320 = YES;
    if (bSupportIPP320) {
        //support IPP320
        [properties setValue:@"ETHERNET" forKey:Prop_PinpadInterface];
        [properties setValue:@"192.168.88.237" forKey:Prop_PinpadIP];//you need set the IPP320 run as server,and get the IP addr.
        [properties setValue:@12000 forKey:Prop_PinpadPort];
    }
    else{
        //support ICMP
        [properties setValue:@"BT" forKey:Prop_PinpadInterface];
    }
    
    [m_iPDC setProperties:properties];
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


- (void)displayAlertWithMessage:(NSString *)message {
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"" message:message preferredStyle:UIAlertControllerStyleAlert];
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleCancel handler:nil];
    [alertController addAction:okAction];
    [self presentViewController:alertController animated:YES completion:nil];
}

- (IBAction)sendRequestClick:(id)sender {
    
    NSString* request = @"{\"GMID\":\"2001003223\",\"GTID\":\"GT3010020919\",\"GMPW\":\"03\",\"TransType\":\"Sale\",\"Medium\":\"Credit\",\"MainAmt\":\"100\",\"NeedSwipeCard\":\"Y\"}";
    [m_iPDC postTransactionToUrl:URL_testlink  request:request withTimeout:120];
}

- (IBAction)readCardClick:(id)sender {
    NSString* request = @"{\"TransType\":\"ReadTrackData\"}";
    [m_iPDC performAction:request];
}

-(void) TransDataReceived:(NSData*)data
{
    NSError *requestError;
    NSDictionary *json = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:&requestError];
    NSLog(@"TRANS DATA [%@]",json);
    [self displayAlertWithMessage:[NSString stringWithFormat:@"TRANS DATA [%@]",json]];
    if ([json[@"Status"] isEqualToString:@"success"]) {//the transaction is completed with approval.
        NSLog(@"Response code:%@",json[@"ResponseCode"]);
        NSLog(@"Auth code:%@",json[@"AuthCode"]);
        NSLog(@"Auth amout:%@",json[@"AuthAmt"]);
    }
    else{
        NSLog(@"Error code:%@",json[@"ErrorCode"]);
        NSLog(@"Error text:%@",json[@"ErrorText"]);
    }
}

-(void) ActionDataReceived:(NSData*)data
{
    NSError *requestError;
    NSDictionary *json = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:&requestError];
    NSLog(@"TRACK DATA [%@]",json);
    [self displayAlertWithMessage:[NSString stringWithFormat:@"TRACK DATA [%@]",json]];
    if ([json[@"Status"] isEqualToString:@"success"]) {//read track data successfully.
        NSLog(@"track data:%@",json[@"Track2"]);
    }
    else{
        NSLog(@"Error code:%@",json[@"ErrorCode"]);
        NSLog(@"Error text:%@",json[@"ErrorText"]);
    }
}

-(void) deviceConnected
{
    NSLog(@"pinpad connected");
    [[self m_status] setText:@"pinpad connected"];
}

-(void) deviceDisconnected
{
    NSLog(@"pinpad disconnected");
    [[self m_status] setText:@"pinpad disconnected"];
}

@end
