//
//  CommDefine.h
//  iPDCLib
//
//  Created by jije jijesoft on 2018/9/20.
//  Copyright © 2018年 jijesoft. All rights reserved.
//

#ifndef CommDefine_h
#define CommDefine_h

#define MAX_RESENDCNT 2
#define TIME_WAIT_ACK 10
#define TIME_WAIT_MSG 60

#define _PinPadSucc_ 0
#define _PinPadFail_ -1
#define _PinPadCancel_ -2
#define _PinPadTimeOut_ -3
#define _PinPadUnavailable_ -4
#define _PinPadNoDefine_ -5

// SWIP
#define _MSRNormalResp_ 1
// Write response to PinPad successful( local and host)
#define _EMVHostAndPinPadApproved_ 2
// transaction fail(local and host)
#define _EMVHostAndPinPadDeclined_ 3
// Write response to PinPad fail but the transaction is successful, we need
#define _EMVHostOrPinPadDeclined_  4
// reversal this transaction
#define _EMVTransactionContinue_ 5

#define _EMV0057_ "EMV57"
#define _EMV0099_ "EMV99"
#define _EMVFF1F_ "EMVFF1F"
#define _EMVFF20_ "EMVFF20"
#define _EMVFF21_ "EMVFF21"
#define _EMV008A_ "EMV8A"
#define _EMV9001_ "EMV9001"
#define _EMV1003_ "EMV1003"
#define _EMV0071_ "EMV71"
#define _EMV0072_ "EMV72"
#define _EMV008A_ "EMV8A"
#define _EMV0091_ "EMV91"
#define _EMV1004_ "EMV1004"
#define _EMV1007_ "EMV1007"
#define _EMV1008_ "EMV1008"
#define _EMV1009_ "EMV1009"
#define _EMV100A_ "EMV100A"
#define _EMV100B_ "EMV100B"
#define _EMV100C_ "EMV100C"
#define _EMV100D_ "EMV100D"
#define _EMV1010_ "EMV1010"

#define _EMV9F6E_ "EMV9F6E"

#define FUN_FALSE_RETURN(FUN) \
if (NO == FUN)         \
{                         \
return NO;         \
}

#define  _PinpadSerial_              "PinpadSerial"
#define  _TransSerial_               "TransSerial"

@protocol PinPad <NSObject>
-(BOOL) connectToPinPad;
-(void) disconnectFromPinPad;
-(BOOL) isOpen;
-(void) send:(NSData*) data;
//-(BOOL) send:(NSData*) data withResponse:(NSMutableData*) response withTimeout:(int) timeOut;
//-(BOOL) waitResponse:(NSMutableData*)response withTimeout:(int) timeOut;
-(BOOL) pullMsg:(NSMutableData*) packet;
@end

@protocol PinPadNotify <NSObject>
-(void) deviceConnected;
-(void) deviceDisconnected;
@end

#endif /* CommDefine_h */
